(*************************************************************************)
(*                                                                       *)
(*                                OCaPIC                                 *)
(*                                                                       *)
(*            Benoit Vaugon, Université Pierre et Marie Curie            *)
(*                                                                       *)
(*    Ce fichier est distribué sous les termes de la licence CeCILL-B    *)
(*    décrite dans le fichier ../../LICENCE.                             *)
(*                                                                       *)
(*************************************************************************)

open Pic;;
open Lcd;;
open Serial;;

set_bit IRCF1;;
set_bit IRCF0;;
set_bit PLLEN;;

module Disp = Connect (
struct
  let bus_size = Eight
  let e  = LATD0
  let rs = LATD2
  let rw = LATD1
  let bus = PORTB
end
);;
open Disp;;

init ();;
config ~cursor:Underscore ();;

type t = Clear | Moveto of int * int | Int of int | Text of string

let (chan : (unit, t) channel) = open_channel 34;; (* 19200 bauds *)

while true do
  match receive chan with
    | Clear -> clear ()
    | Moveto (l, c) -> moveto l c
    | Int i -> print_int i
    | Text t ->	print_string t
done
